/*
;;; 07/26/96 gb lisp_bug
;;; 06/17/96 bill condemn_area -> condemn_area_chain
;;; 06/20/96 gb lisp_egc_control
;;; ---- 3.9
;;; 04/09/96 gb excise_library
;;; 03/01/96 gb add metering_control
;;; 01/31/96 gb add condemn_area
;;; 12/03/95 gb add allocate_vstack, allocate_tstack, register_cstack
*/
	.globl import_ptrs_base

	.macro 	defimport name
	.globl \name
	.long \name
	.endm

	.data
import_ptrs_start:

	defimport read
	defimport write
	defimport open
	defimport close
	defimport ioctl_1
	defimport MakeDataExecutable
	defimport GetSharedLibrary
	defimport FindSymbol
	defimport CountSymbols
	defimport GetIndSymbol
	defimport allocate_tstack
	defimport allocate_vstack
	defimport register_cstack
	defimport condemn_area_chain
	defimport metering_control
	defimport excise_library
	defimport lisp_egc_control
	defimport lisp_bug
	defimport lseek
	defimport allocate
	defimport deallocate
	defimport xftruncate
	defimport dlsym1
	defimport NewThread
	defimport DisposeThread
	defimport YieldToThread
	defimport ThreadCurrentStackSpace
	defimport lookuphost
	defimport fd_setsize_bytes
	defimport do_fd_set
	defimport do_fd_clr
	defimport do_fd_is_set
	defimport do_fd_zero
	defimport create_proxy_task
	defimport pop_proxy_q
	defimport kill_proxy
	defimport proxy_wait
	defimport proxy_wait_mutex
	defimport proxy_wait_select_input
	defimport proxy_wait_counting_semaphore
	defimport proxy_wait_timeout
	defimport current_task_priority
	defimport x_readdir
	defimport allocate_proxy_events
	defimport retrieve_proxy_events
	defimport record_proxy_event
	defimport xdlopen
	defimport open_client_socket
	defimport open_server_socket
	defimport accept_client_socket
	defimport proxy_interrupt
	defimport proxy_restore
	defimport xgetcwd

import_ptrs_base:	
	.long import_ptrs_start

	.globl subprims_base
	.globl ret1valn
	.globl lexpr_return
	.globl lexpr_return1v
	.globl start_lisp


#ifndef VXWORKS
	.weak .subprims_base
	.weak .start_lisp
	.weak .nvalret
	.weak .popj
	.weak .ret1valn

subprims_base:	
	.long .subprims_base
start_lisp:	
	.long .start_lisp
ret1valn:	
	.long .ret1valn
lexpr_return:	
	.long .nvalret
lexpr_return1v:	
	.long .popj

#else				
subprims_base:	
	.long 0
start_lisp:	
	.long 0
ret1valn:	
	.long 0
lexpr_return:	
	.long 0
lexpr_return1v:	
	.long 0
	.globl vx_signal
	.globl init_vxlow
	.globl vxlow_cleanup
vx_signal:
	.long 0
init_vxlow:
	.long 0
vxlow_cleanup:
	.long 0

#endif
