/*
  MCL-PPC dcmd utilities.
*/

#include "lispdcmd.h"




void
display_buffer(char *buf)
{
  fprintf(stdout, "%s\n", buf);
}

int
Dprintf(const char *format, ...)
{
  char buf[512];
  va_list args;
  int res;

  va_start(args, format);
  res = vsprintf(buf, format, args);
  if (res >= 0) {
    display_buffer(buf);
  }
  return res;
}

