changecom(`/*', `*/')


/*
  Note that m4 macros that could be expanded in the .text segment
  need to advertise the current line number after they've finished
  expanding.  That shouldn't be too onerous, if only because there
  shouldn't be too many of them.
*/

define(`N_FUN',36)
define(`N_SO',100)
/*
    I wish that there was a less-dumb way of doing this.
*/
define(`pwd0',esyscmd(`/bin/pwd'))
define(`__pwd__',substr(pwd0,0,decr(len(pwd0)))`/')

/*
   _beginfile() -- gets line/file in synch, generates N_SO for file,
   starts .text section
*/

define(`_beginfile',`
	.stabs "__pwd__",N_SO,0,0,.Ltext0
	.stabs "__file__",N_SO,0,0,.Ltext0
	.section ".text"
.Ltext0:
# __line__ "__file__"
')

define(`_endfile',`
	.stabs "",N_SO,0,0,.Letext
.Letext:
# __line__
')

define(`_startfn',`
	.type $1,@function
$1:	.stabs "$1:F(0,1)",N_FUN,0,__line__,$1
	.autoline $1
# __line__
')

define(`_exportfn',`
	.global $1
	_startfn($1)
# __line__
')

define(`_endfn',`
	.noautoline
.Lfe$1:	.stabs "",N_FUN,0,0,.Lfe$1-$1
# __line__
')

define(`_spentry',`
	_exportfn(_SP$1)
$1:
# __line__
')

define(`_endsubp',`
	_endfn(_SP$1)
# __line__
')

/* _struct(name,start_offset)
   This just generates a bunch of assembler equates; m4
   doesn't remember much of it ... */
define(`_struct', `define(`__struct_name',$1)
 define(`_struct_org_name', _$1_org) 
 define(`_struct_base_name', _$1_base) 
	.equiv _struct_org_name,$2
	.equiv _struct_base_name,_struct_org_name')

define(`_struct_pad',`
	_struct_org_name = _struct_org_name + $1
')
 
define(`_struct_label',`
	.equiv __struct_name`.'$1, _struct_org_name
')

/*  _field(name,size) */
define(`_field',`_struct_label($1) _struct_pad($2)')

define(`_halfword', `_field($1, 2)')
define(`_word', `_field($1, 4)')
define(`_dword',`_field($1, 8)')

define(`_ends',`
	.equiv  __struct_name`.size', _struct_org_name-_struct_base_name
')

/* 
   Lisp fixed-size objects always have a 1-word header
   and are always accessed from a "fulltag_misc"-tagged pointer.
   We also want to define STRUCT_NAME.element-count for each
   such object.
*/

define(`_structf',`
	_struct($1,-fulltag_misc)
	 _word(header)
')

define(`_endstructf',`
	.equiv __struct_name.`element_count',((_struct_org_name-4)-_struct_base_name)/4
	_ends
')





