;;;-*- Mode: Lisp; Package: CCL -*-

;; l1-boot-3.lisp
;; Third part of l1-boot

;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Modification History
;;
;; 04/16/97 bill  New file. Broken out of l1-boot.lisp
;;

(catch :toplevel
    (or (find-package "COMMON-LISP-USER")
        (make-package "COMMON-LISP-USER" :use '("COMMON-LISP" "CCL") :NICKNAMES '("CL-USER")))
)

(set-periodic-task-interval 1)


(progn (%set-toplevel #'toplevel-loop) (toplevel))

(defvar *LISTENER-PROCESS-STACKSEG-SIZE* (* 4 16384))

(setq *interrupt-level* 0)

(setq *warn-if-redefine* t)

(setq *level-1-loaded* t)

;(setq *loading-file-source-file* "ccl:l1;level-1.lisp") ;reset from last %fasload...

;End of Level-1.lisp
