; -*- Mode:Lisp; Package:CCL; -*-
;
; appgen-defs.lisp - compile-time definitions for building AppGen
; Copyright 1995 Digitool, Inc.

; Change History:
;
;  8/14/96 slh   home:MCL-AppGen -> ccl:MCL-AppGen

(in-package :ccl)

(defconstant appgen-app-name "ccl:MCL-AppGen")
(defconstant appgen-creator    :|APGN|)
(defconstant modules-file-type :|cclM|)     ; really a text file, but hide its contents

; undo the errors of the past...
(when (constantp '*genapp-src*)
  (makunbound '*genapp-src*))
(when (constantp '*genapp-fsl*)
  (makunbound '*genapp-fsl*))

(defconstant *appgen-folder* "AppGen")
(defconstant *appgen-lisp-path* "ccl:AppGen;AppGen.lisp")
(defconstant *appgen-fasl-path* "ccl:AppGen;AppGen.fasl")

(declaim (special *application-info*
                  *app-name*
                  *app-modules*
                  *app-error-handler-mode*))

; End of appgen-defs.lisp
