/* 
   Some subset of the MacOS Thread Manager API.
*/

typedef unsigned long ThreadID;
enum {
  kNoThreadID = 0, 
  kCurrentThreadID = 1, 
  kApplicationThreadID = 2
};


typedef unsigned long Size;
typedef unsigned long ThreadStyle;
enum {
	kCooperativeThread			= 1L << 0,
	kPreemptiveThread			= 1L << 1
};
typedef void *voidPtr;
typedef void (*ThreadEntryProcPtr)();
typedef void (*ProcPtr)();

typedef unsigned long ThreadOptions;
enum {
	kNewSuspend					= (1 << 0),
	kUsePremadeThread			= (1 << 1),
	kCreateIfNeeded				= (1 << 2),
	kFPUNotNeeded				= (1 << 3),
	kExactMatchThread			= (1 << 4)
};

