
/* 07/04/96 bill breakpoint */
/* 06/15/96 gb   subprims for builtin functions. */
/* ---- 3.9 release */
/* 03/01/96 bill add ffcallslep */
/* 01/18/96 gb  add restorecontext, lexpr_entry. */
/* 12/13/95 gb  progvsave,progvrestore, callbuiltin*, popj; */
/*              save/restore context; udfcall->reset */
/* 11/29/95  gb   stack_misc_alloc_init, misc_alloc_init */
/* 11/11/95 bill  Add callback */
/* 11/06/95  gb   replace duplicate regtrap with stack_misc_alloc */
	
	include(lisp.s)
	_beginfile	

	.set nsubps,0
	.set maxsubps,255

	.macro defsubp shortname
 	.ifne nsubps-maxsubps
	 .globl _SP\shortname
	 b _SP\shortname
	 .set nsubps,nsubps+1
	.else
	 .err
	.endif
 	.endm
	
	.macro padsubp
	.org .sp_jump+(maxsubps*4)
	.long 0
	.endm

_exportfn(.subprims_base)
.sp_jump:
	defsubp jmpsym
	defsubp jmpnfn
	defsubp funcall
	defsubp mkcatch1v
	defsubp mkunwind
	defsubp mkcatchmv
	defsubp throw
	defsubp nthrowvalues
	defsubp nthrow1value
	defsubp bind
	defsubp bind_self
	defsubp bind_nil
	defsubp unbind
	defsubp unbind_n
	defsubp unbind_to
	defsubp conslist
	defsubp conslist_star
	defsubp stkconslist
	defsubp stkconslist_star
	defsubp mkstackv
	defsubp subtag_misc_ref
	defsubp newblocktag
	defsubp newgotag
	defsubp stack_misc_alloc
	defsubp gvector
	defsubp nvalret
	defsubp mvpass
	defsubp fitvals
	defsubp nthvalue
	defsubp values
	defsubp default_optional_args
	defsubp opt_supplied_p
	defsubp heap_rest_arg
	defsubp req_heap_rest_arg
	defsubp heap_cons_rest_arg
	defsubp simple_keywords
	defsubp keyword_args
	defsubp keyword_bind
	defsubp ffcall
	defsubp ffcalladdress
	defsubp ksignalerr
	defsubp stack_rest_arg
	defsubp req_stack_rest_arg
	defsubp stack_cons_rest_arg
	defsubp strap
	defsubp call_closure
	defsubp getxlong
	defsubp spreadargz
	defsubp tfuncallgen
	defsubp tfuncallslide
	defsubp tfuncallvsp
	defsubp tcallsymgen
	defsubp tcallsymslide
	defsubp tcallsymvsp
	defsubp tcallnfngen
	defsubp tcallnfnslide
	defsubp tcallnfnvsp
	defsubp misc_ref
	defsubp misc_set
	defsubp stkconsyz
	defsubp stkvcell0
	defsubp stkvcellvsp
	defsubp makestackblock
	defsubp makestackblock0
	defsubp makestacklist
	defsubp stkgvector
	defsubp misc_alloc
	defsubp regtrap
	defsubp bind_self_boundp_check
	defsubp macro_bind
	defsubp destructuring_bind
	defsubp destructuring_bind_inner
	defsubp recover_values
	defsubp vpopargregs
	defsubp integer_sign
	defsubp subtag_misc_set
	defsubp spread_lexprz
	defsubp setqsym
	defsubp reset
	defsubp mvslide
	defsubp save_values
	defsubp add_values
	defsubp callback
	defsubp misc_alloc_init
	defsubp stack_misc_alloc_init
        defsubp progvsave
        defsubp progvrestore
	defsubp callbuiltin
	defsubp callbuiltin0
	defsubp callbuiltin1
	defsubp callbuiltin2
	defsubp callbuiltin3
	defsubp popj
	defsubp restorefullcontext
	defsubp savecontextvsp
	defsubp savecontext0
	defsubp restorecontext
	defsubp lexpr_entry
	defsubp ffcallslep
	defsubp builtin_plus
	defsubp builtin_minus
	defsubp builtin_times
	defsubp builtin_div
	defsubp builtin_eq
	defsubp builtin_ne
	defsubp builtin_gt
	defsubp builtin_ge
	defsubp builtin_lt
	defsubp builtin_le
	defsubp builtin_eql
	defsubp builtin_length
	defsubp builtin_seqtype
	defsubp builtin_assq
	defsubp builtin_memq
	defsubp builtin_logbitp
	defsubp builtin_logior
	defsubp builtin_logand
	defsubp builtin_ash
	defsubp builtin_negate
	defsubp builtin_logxor
	defsubp builtin_aref1
	defsubp builtin_aset1
	defsubp breakpoint
	defsubp eabi_ff_call
	defsubp eabi_callback
	padsubp
	_endfile
