#include "Threads.h"
#include <stdio.h>
#include <signal.h>

void
signal_handler(int signum)
{
  fprintf(stderr, "Signal %d \n", signum);
  exit(1);
}

void
bogus()
{
  __asm__ volatile("li 3,51");
  __asm__ volatile("tweqi 3,51");
}
   
void
threadentry(void *param)
{
  ThreadID next  = (ThreadID)param;

  bogus();
  fprintf(stderr, "next thread = %d\n", next);
  YieldToThread(next);
}

main()
{
  ThreadID first, second;
  extern void init_mac_threads(void);
  init_mac_threads();
  signal(SIGSEGV, signal_handler);
  signal(SIGILL, signal_handler);
  if (NewThread(kCooperativeThread,
		threadentry,
		(void *)kApplicationThreadID,
		(16<<10),
		kCreateIfNeeded,
		NULL,
		&first) == 0) {
    if (NewThread(kCooperativeThread,
		  threadentry,
		  (void *)first,
		  (16<<10),
		  kCreateIfNeeded,
		  NULL,
		  &second) == 0) {
      fprintf(stderr, "next thread = %d\n", second);
      YieldToThread(second);
      return 0;
    }
  }
}
  
		    
  
